package com.inca.npbusi.sacon.bms_sa_con;

import com.inca.entity.base.Goods;
import com.inca.entity.client.pub.CompanyOnClient;
import com.inca.gsp.service.GSPHelper;
import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.mpcsprodHelper;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import org.apache.log4j.Category;

public class Bms_sa_con_detail extends CDetailModel {
   private ArrayList<String> a = new ArrayList();
   private Category b = Category.getInstance(Bms_sa_con_detail.class);
   private HashMap<String, String> c = new HashMap();
   private HashMap<String, ArrayList<String>> d = new HashMap();

   public Bms_sa_con_detail(CFrame var1, CMdeModel var2) {
      super(var1, "销售订单细单", var2);
      this.getDBColumnDisplayInfo("salesdtlid").setDbcolumn(false);
      DBColumnDisplayInfo var3;
      (var3 = this.getDBColumnDisplayInfo("reqprintquflag")).addComboxBoxItem("0", "不需要");
      var3.addComboxBoxItem("1", "需要");
   }

   public String getTablename() {
      return "bms_sa_con_dtl_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      String var4;
      String var5;
      String var6;
      String var7;
      String var8;
      DBTableModel var17;
      RemotesqlHelper var19;
      if (var2.equals("goodsid")) {
         this.commitEdit();
         super.on_itemvaluechange(var1, var2, var3);
         this.setItemValue(var1, "priceid", "");
         this.setItemValue(var1, "priceopcode", "");
         this.setItemValue(var1, "pricename", "");
         this.setItemValue(var1, "unitprice", "");
         this.setItemValue(var1, "timepriceid", "");
         this.setItemValue(var1, "timepricename", "");
         this.setItemValue(var1, "timeprice", "");
         this.setItemValue(var1, "discount", "");
         var4 = this.getItemValue(this.getRow(), "goodsunit");
         this.setItemValue(this.getRow(), "goodsuseunit", var4);
         var5 = mpcsprodHelper.getSysProdConfig(ClientUserManager.getCurrentUser().getEntryid(), "prod202005");
         if ("1".equals(var5)) {
            this.setItemValue(var1, "priceopcode", "XYJ");
            this.setItemValue(var1, "priceid", "3");
            this.setItemValue(var1, "pricename", "协议价");
         } else {
            this.setItemValue(var1, "priceopcode", "");
         }

         var6 = ClientUserManager.getCurrentUser().getEntryid();
         var7 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         var8 = "select lastsaprice from bms_goods_saprice_custom_ref where customid = " + var7 + " and goodsid = " + var3 + " and entryid=" + var6;
         DBTableModel var18 = null;
         var19 = new RemotesqlHelper();

         try {
            var18 = var19.doSelect(var8, 0, 1);
         } catch (Exception var14) {
            var14.printStackTrace();
         }

         if (var18 != null && var18.getRowCount() > 0) {
            var2 = var18.getItemValue(0, "lastsaprice");
            this.setItemValue(var1, "customlastprice", var2);
         }

         if (!"".equals(var3) && !"1".equals(var5) && this.a(var1)) {
            var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
            var4 = this.getItemValue(var1, "goodsid");
            if (var2 == null || var2.equals("")) {
               this.infoMessage("提示", "请先录入客户");
               return;
            }

            var17 = null;
            ClientRequest var23 = new ClientRequest();
            StringCommand var21 = new StringCommand("根据取价逻辑自动提取价格信息");
            ParamCommand var22;
            (var22 = new ParamCommand()).addParam("customid", var2);
            var22.addParam("goodsid", var4);
            var22.addParam("isgroupsales", "0");
            var22.addParam("entryid", ((Bms_sa_con_mde)this.mdemodel).getEntryid());
            var23.addCommand(var21);
            var23.addCommand(var22);
            ServerResponse var16 = null;

            try {
               var16 = SendHelper.sendRequest(var23);
            } catch (Exception var13) {
               var13.printStackTrace();
            }

            if (((StringCommand)var16.commandAt(0)).getString().startsWith("+OK")) {
               if (var16.commandAt(1) instanceof DataCommand) {
                  var17 = ((DataCommand)var16.commandAt(1)).getDbmodel();
               } else if (var16.commandAt(1) instanceof StringCommand) {
                  var16.commandAt(1);
               }
            }

            if (var17 == null || var17.getRowCount() <= 0) {
               this.infoMessage("提示", "没有取到价格，请先定义价格!");
               return;
            }

            var2 = var17.getItemValue(0, "price");
            String var9 = var17.getItemValue(0, "priceid");
            this.setItemValue(var1, "priceid", var17.getItemValue(0, "priceid"));
            this.setItemValue(var1, "priceopcode", var17.getItemValue(0, "priceopcode"));
            this.setItemValue(var1, "pricename", var17.getItemValue(0, "pricename"));
            this.setItemValue(var1, "unitprice", var2);
            this.setItemValue(var1, "timepriceid", var17.getItemValue(0, "refrencepriceid"));
            this.setItemValue(var1, "timepricename", var17.getItemValue(0, "refrencepricename"));
            this.setItemValue(var1, "timeprice", var17.getItemValue(0, "refrenceprice"));
            this.setItemValue(var1, "discount", var17.getItemValue(0, "discount"));
            this.on_itemvaluechange(var1, "unitprice", var2);
            this.on_itemvaluechange(var1, "priceid", var9);
            var2 = "";
            var9 = "";
            var17 = null;
            var6 = ((Bms_sa_con_mde)this.mdemodel).getEntryid();
            var8 = "select price from pub_price_type a,bms_entry_goods_price b where a.priceid=b.priceid and a.wholeresaleflag=1 and b.goodsid=" + var3 + " and b.entryid=" + var6;
            var19 = new RemotesqlHelper();

            try {
               var17 = var19.doSelect(var8, 0, 1);
            } catch (Exception var12) {
               var12.printStackTrace();
            }

            if (var17 != null && var17.getRowCount() > 0) {
               var2 = var17.getItemValue(0, "price");
            }

            var8 = "select price from pub_price_type a,bms_entry_goods_price b where a.priceid=b.priceid and a.wholeresaleflag=13  and b.goodsid=" + var3 + " and b.entryid=" + var6;

            try {
               var17 = var19.doSelect(var8, 0, 1);
            } catch (Exception var11) {
               var11.printStackTrace();
            }

            if (var17 != null && var17.getRowCount() > 0) {
               var9 = var17.getItemValue(0, "price");
            }

            this.setItemValue(var1, "wholesaleprice", var2);
            this.setItemValue(var1, "resaleprice", var9);
            if ((var8 = NpbusiDBHelper.getSysParaConfig(var6, "nosapriceinfo")) != null && var8.equals("1") && !this.a(var4)) {
               this.infoMessage("友情提示", "ID为" + var4 + "的货品尚未定义零售价，请及时维护!~");
            }

            this.setItemValue(var1, "oldunitprice", this.getItemValue(var1, "unitprice"));
         }

         var2 = this.getItemValue(var1, "goodsid");
         var5 = null;
         var8 = "select a.modeltype from pub_goods a where a.goodsid=" + var2;
         RemotesqlHelper var20 = new RemotesqlHelper();

         try {
            if ((var17 = var20.doSelect(var8, 0, 1)) != null && var17.getRowCount() > 0) {
               var6 = var17.getItemValue(0, "modeltype");
               this.setItemValue(var1, "modeltype", var6);
               return;
            }
         } catch (Exception var10) {
            var10.printStackTrace();
         }

      } else {
         if (var2.equals("goodsqty")) {
            var4 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "exchange");
            var6 = DecimalHelper.multi(this.getItemValue(var1, "unitprice"), var3, 2);
            if (var4 != null && !var4.equals("")) {
               var6 = DecimalHelper.multi(var6, var4, 2);
            }

            this.setItemValue(var1, "total_line", var6);
            var7 = this.getItemValue(var1, "webgoodsqty");
            var8 = DecimalHelper.trimZero(var3);
            if (var7 != null && !"".equals(var7) && DecimalHelper.comparaDecimal(var8, var7) > 0) {
               this.infoMessage("提示", "货品数量" + var8 + "大于原网上订单审批数量" + var7 + "！");
               this.commitEdit();
               return;
            }
         } else if (var2.equals("oldunitprice")) {
            var4 = this.getItemValue(var1, "discount");
            var5 = DecimalHelper.multi(var3, var4, 10);
            this.setItemValue(var1, "unitprice", var5);
         } else if (var2.equals("unitprice")) {
            var5 = DecimalHelper.multi(this.getItemValue(var1, "goodsqty"), var3, 2);
            this.setItemValue(var1, "total_line", var5);
            if ((var6 = this.getItemValue(var1, "oldunitprice")).equals("") || var6 == null) {
               var6 = var3;
            }

            if (DecimalHelper.toDec(var6).compareTo(DecimalHelper.toDec("0")) != 0) {
               var7 = DecimalHelper.divide(var3, var6, 4);
               this.setItemValue(var1, "discount", var7);
            }
         } else if (var2.equals("goodsuseqty") && !"".equals(var3)) {
            if ((var4 = this.getItemValue(var1, "goodsuseunit")).indexOf("(") == -1) {
               var5 = "1";
            } else {
               var5 = var4.substring(var4.indexOf("(") + 1, var4.indexOf(")"));
            }

            var6 = DecimalHelper.multi(var3, var5, 6);
            this.setItemValue(var1, "goodsqty", var6);
            this.on_itemvaluechange(var1, "goodsqty", var6);
         } else if (var2.equals("goodsuseunit") && !"".equals(var3)) {
            var4 = this.getItemValue(var1, "goodsuseqty");
            if (var3.indexOf("(") == -1) {
               var5 = "1";
            } else {
               var5 = var3.substring(var3.indexOf("(") + 1, var3.indexOf(")"));
            }

            this.setItemValue(var1, "usepacksize", var5);
            var6 = DecimalHelper.multi(var4, var5, 6);
            this.setItemValue(var1, "goodsqty", var6);
            this.on_itemvaluechange(var1, "goodsqty", var6);
         } else if (var2.equals("priceid")) {
            var4 = "";
            var17 = null;
            var6 = " select modifyflag from pub_price_type where priceid = " + var3;
            var19 = new RemotesqlHelper();

            try {
               var17 = var19.doSelect(var6, 0, 1);
            } catch (Exception var15) {
               var15.printStackTrace();
            }

            if (var17 != null && var17.getRowCount() > 0) {
               var4 = var17.getItemValue(0, "modifyflag");
            }

            if ("1".equals(var4)) {
               this.getDBColumnDisplayInfo("unitprice").setReadonly(false);
            } else {
               this.getDBColumnDisplayInfo("unitprice").setReadonly(true);
            }

            var8 = this.getItemValue(var1, "goodsid");
            var4 = this.b(var8);
            var7 = DecimalHelper.multi(this.getItemValue(var1, "unitprice"), var4, 10);
            this.setItemValue(var1, "discount", var4);
            this.setItemValue(var1, "unitprice", var7);
            this.on_itemvaluechange(var1, "unitprice", var7);
         } else if ("discount".equals(var2) && !"".equals(var3)) {
            var4 = this.getItemValue(var1, "oldunitprice");
            var5 = DecimalHelper.multi(var3, var4, 10);
            this.setItemValue(var1, "unitprice", var5);
            this.on_itemvaluechange(var1, "unitprice", var5);
         }

         super.on_itemvaluechange(var1, var2, var3);
      }
   }

   private boolean a(String var1) {
      ClientRequest var2 = new ClientRequest();
      StringCommand var3 = new StringCommand("销售订单管理.检查没有是否有零售价");
      ParamCommand var4;
      (var4 = new ParamCommand()).addParam("goodsid", var1);
      var4.addParam("entryid", ((Bms_sa_con_mde)this.mdemodel).getEntryid());
      var2.addCommand(var3);
      var2.addCommand(var4);
      ServerResponse var6 = null;
      boolean var7 = true;

      try {
         var6 = SendHelper.sendRequest(var2);
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      if (((StringCommand)var6.commandAt(0)).getString().startsWith("+OK") && (var1 = ((StringCommand)var6.commandAt(1)).getString()) != null) {
         if (var1.equals("0")) {
            var7 = false;
         } else if (var1.equals("1")) {
            var7 = true;
         }
      }

      return var7;
   }

   private String b(String var1) {
      ClientRequest var2 = new ClientRequest();
      StringCommand var3 = null;
      var3 = new StringCommand("销售发货单管理:获取销售折扣");
      ParamCommand var4 = new ParamCommand();
      String var5 = null;
      var5 = null;
      int var10 = this.mdemodel.getMasterModel().getRow();
      var5 = this.mdemodel.getMasterModel().getItemValue(var10, "customid");
      String var6 = ((Bms_sa_con_mde)this.mdemodel).getEntryid();
      String var7 = "1";
      var4.addParam("goodsid", var1);
      var4.addParam("customid", var5);
      var4.addParam("entryid", var6);
      var2.addCommand(var3);
      var2.addCommand(var4);

      try {
         ServerResponse var9;
         if (((StringCommand)(var9 = SendHelper.sendRequest(var2)).commandAt(0)).getString().startsWith("+OK")) {
            var7 = ((ParamCommand)var9.commandAt(1)).getValue("discount");
         }
      } catch (Exception var8) {
         var8.printStackTrace();
      }

      return var7;
   }

   public boolean canInvokehov(String var1) {
      String var2;
      if (var1.equals("priceopcode")) {
         var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         String var3 = this.getItemValue(this.getRow(), "goodsid");
         if (var2 == null || var2.equals("")) {
            this.infoMessage("提示", "请先录入客户！");
            return false;
         }

         if (var3 == null || var3.equals("")) {
            this.infoMessage("提示", "请先录入货品！");
            return false;
         }
      }

      var2 = mpcsprodHelper.getSysProdConfig(ClientUserManager.getCurrentUser().getEntryid(), "prod202005");
      if (var1.equals("conno") && "1".equals(var2)) {
         var1 = this.getItemValue(this.getRow(), "agreementflag");
         if ("1".equals(var1)) {
            return true;
         } else {
            return false;
         }
      } else {
         return true;
      }
   }

   public String getHovOtherWheres(int var1, String var2) {
      String var3 = ((Bms_sa_con_mde)this.mdemodel).getEntryid();
      if (var2.equals("priceopcode")) {
         var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         String var4 = this.getItemValue(var1, "goodsid");
         return "(customid is null or customid = " + var2 + ") and goodsid = " + var4 + " and entryid=" + var3;
      } else if (var2.equals("opcode")) {
         return this.a();
      } else {
         return var2.equals("agrconno") ? this.b() : super.getHovOtherWheres(var1, var2);
      }
   }

   private String a() {
      int var1 = this.mdemodel.getMasterModel().getRow();
      String var5 = this.mdemodel.getMasterModel().getItemValue(var1, "customid");
      CompanyOnClient var6;
      (var6 = new CompanyOnClient(var5)).setCompanyType(2);
      String var2;
      String var3 = GSPHelper.getGoodsOtherWheresOnHov(var2 = ((Bms_sa_con_mde)this.mdemodel).getEntryid(), "pub_goods_dtl_hov_v", "goodsid", true, false);

      try {
         var3 = var3 + var6.sendLimitCheck("3", var2);
         return var3;
      } catch (Exception var4) {
         this.errorMessage("获取供应商经营范围、类别时错误", var4.getMessage());
         return "";
      }
   }

   private String b() {
      String var1 = this.getItemValue(this.getRow(), "goodsid");
      this.c(var1);
      if (this.a.size() == 0) {
         return null;
      } else {
         int var4 = this.a.size();
         String var2 = (String)this.a.get(0);

         for(int var3 = 1; var3 < var4; ++var3) {
            var2 = var2 + "," + (String)this.a.get(var3);
         }

         this.a.clear();
         return "agrcondtlid in (" + var2 + ")";
      }
   }

   protected int on_new(int var1) {
      this.getDBColumnDisplayInfo("unitprice").setReadonly(true);
      this.setItemValue(var1, "invalidflag", "0");
      this.setItemValue(var1, "speciallotflag", "0");
      this.setItemValue(var1, "discount", "1");
      String var2 = ((Bms_sa_con_mde)this.mdemodel).getEntryid();
      int var3 = this.mdemodel.getMasterModel().getRow();
      String var9 = this.mdemodel.getMasterModel().getItemValue(var3, "customid");
      String var4 = (String)this.c.get(var9);
      RemotesqlHelper var5 = null;
      if (var4 == null) {
         DBTableModel var10 = null;
         var2 = "select nvl(v.reqprintquflag,0)reqprintquflag from pub_company_to_definfo v where v.companyid=" + var9 + " and (v.entryid is null or v.entryid=" + var2 + ") order by nvl(v.entryid,-1) desc";
         var5 = new RemotesqlHelper();

         try {
            var10 = var5.doSelect(var2, 0, 1);
         } catch (Exception var7) {
            this.b.error("error", var7);
            this.errorMessage("错误", var7.getMessage());
         }

         ArrayList var8;
         String var12;
         if (var10 != null && var10.getRowCount() > 0) {
            var12 = var10.getItemValue(0, "reqprintquflag");
            this.c.put(var9, "1");
            this.setItemValue(var1, "reqprintquflag", var12);
            (var8 = new ArrayList()).add(var12);
            this.d.put(var9, var8);
         } else {
            var2 = "select nvl(reqprintquflag,0)reqprintquflag from pub_customer where customid=" + var9;

            try {
               if ((var10 = var5.doSelect(var2, 0, 1)) != null && var10.getRowCount() > 0) {
                  var12 = var10.getItemValue(0, "reqprintquflag");
                  this.c.put(var9, "1");
                  this.setItemValue(var1, "reqprintquflag", var12);
                  (var8 = new ArrayList()).add(var12);
                  this.d.put(var9, var8);
               }
            } catch (Exception var6) {
               var6.printStackTrace();
            }
         }
      } else {
         ArrayList var11 = (ArrayList)this.d.get(var9);
         this.setItemValue(var1, "reqprintquflag", (String)var11.get(0));
      }

      return super.on_new(var1);
   }

   private boolean a(int var1) {
      boolean var2 = false;
      String var3 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
      String var4 = this.getItemValue(var1, "goodsid");
      String var5 = this.getItemValue(var1, "batchid");
      if (var3 != null && !var3.equals("")) {
         ClientRequest var6 = new ClientRequest();
         StringCommand var7 = new StringCommand("禁销限销判断");
         ParamCommand var8;
         (var8 = new ParamCommand()).addParam("customid", var3);
         var8.addParam("goodsid", var4);
         var8.addParam("batchid", var5);
         var3 = ClientUserManager.getCurrentUser().getEntryid();
         var8.addParam("entryid", var3);
         var6.addCommand(var7);
         var6.addCommand(var8);
         ServerResponse var10 = null;

         try {
            var10 = SendHelper.sendRequest(var6);
         } catch (Exception var9) {
            var9.printStackTrace();
         }

         StringCommand var11 = (StringCommand)var10.commandAt(0);
         var5 = null;
         if (var11.getString().startsWith("+OK")) {
            var5 = ((StringCommand)var10.commandAt(1)).getString();
            if ("true".equals(var5)) {
               var2 = true;
            } else {
               var2 = false;
            }
         }

         if (!var2) {
            this.infoMessage("提示", "此货品禁止对本客户销售,请重新选择");
            this.setItemValue(var1, "opcode", "");
         }

         return var2;
      } else {
         this.infoMessage("提示", "请先录入客户");
         this.setItemValue(var1, "opcode", "");
         return false;
      }
   }

   public void on_doubleclick(final int var1, int var2) {
      this.setFocus("opcode");
      super.on_doubleclick(var1, var2);
      SwingUtilities.invokeLater(new Runnable() {
         public final void run() {
            String var1x = Bms_sa_con_detail.this.getItemValue(var1, "goodsid");
            Bms_sa_con_detail.super.on_itemvaluechange(var1, "goodsid", var1x);
         }
      });
   }

   public int on_hov(int var1, String var2, DBTableModel var3) {
      super.on_hov(var1, var2, var3);
      if (var3 != null && var3.getRowCount() != 0) {
         String var4;
         if (var2.equals("opcode")) {
            var4 = var3.getItemValue(0, "goodsid");
            int var7 = this.mdemodel.getMasterModel().getRow();
            if (!(new CompanyOnClient(this.mdemodel.getMasterModel().getItemValue(var7, "customid"))).sentLimitCheck("3", ((Bms_sa_con_mde)this.mdemodel).getEntryid(), new Goods(var4))) {
               return 0;
            }

            int var5 = this.mdemodel.getMasterModel().getRow();
            String var8 = this.mdemodel.getMasterModel().getItemValue(var5, "customid");
            if (!"".equals(a(var8, var3, 0))) {
               this.infoMessage("提示", a(var8, var3, 0));
               this.setItemValue(var1, "opcode", "");
               return -1;
            }

            var8 = mpcsprodHelper.getSysProdConfig(ClientUserManager.getCurrentUser().getEntryid(), "prod202005");
            if ("1".equals(var8)) {
               this.c(var4);
            }
         }

         if (var2.equals("agrconno")) {
            var4 = mpcsprodHelper.getSysProdConfig(ClientUserManager.getCurrentUser().getEntryid(), "prod202005");
            if ("1".equals(var4)) {
               this.setItemValue(this.getRow(), "invprice", var3.getItemValue(0, "invprice"));
               this.setItemValue(this.getRow(), "unitprice", var3.getItemValue(0, "unitprice"));
            } else {
               this.setItemValue(this.getRow(), "invprice", "");
            }
         }

         return super.on_hov(var1, var2, var3);
      } else {
         return 0;
      }
   }

   private void c(String var1) {
      this.a.clear();
      DBColumnDisplayInfo var2 = this.getDBColumnDisplayInfo("agrconno");
      int var3 = this.mdemodel.getMasterModel().getRow();
      String var4 = this.mdemodel.getMasterModel().getItemValue(var3, "customid");
      String var7 = this.mdemodel.getMasterModel().getItemValue(var3, "credate");
      var1 = "select a.agrcondtlid,b.agrconno,a.unitprice ,a.invprice from BMS_sa_agreement_dtl a,BMS_sa_agreement_doc b where a.agrconid=b.agrconid(+) and a.goodsid=" + var1 + " and b.customerid=" + var4 + "and b.validbegindate <= to_date('" + var7 + "','yyyy-mm-dd hh24:mi:ss') and b.validenddate >=  to_date('" + var7 + "','yyyy-mm-dd hh24:mi:ss')";
      DBTableModel var8 = null;
      RemotesqlHelper var9 = new RemotesqlHelper();

      try {
         var8 = var9.doSelect(var1, 0, 10000000);
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      var1 = mpcsprodHelper.getSysProdConfig(ClientUserManager.getCurrentUser().getEntryid(), "prod202005");
      if (var8 != null && var8.getRowCount() > 0) {
         var2.setReadonly(false);
         this.setItemValue(this.getRow(), "agreementflag", "1");
         if ("1".equals(this.getItemValue(this.getRow(), "agreementflag"))) {
            this.getDBColumnDisplayInfo("unitprice").setReadonly(true);
         }

         if (var8.getRowCount() == 1) {
            if ("1".equals(var1)) {
               this.setItemValue(this.getRow(), "unitprice", var8.getItemValue(0, "unitprice"));
               this.setItemValue(this.getRow(), "invprice", var8.getItemValue(0, "invprice"));
               this.setItemValue(this.getRow(), "priceopcode", "XYJ");
               this.setItemValue(this.getRow(), "pricename", "协议价");
               this.setItemValue(this.getRow(), "priceid", "3");
            } else {
               this.setItemValue(this.getRow(), "invprice", "");
            }

            this.setItemValue(this.getRow(), "agrconno", var8.getItemValue(0, "agrconno"));
            this.setItemValue(this.getRow(), "agrcondtlid", var8.getItemValue(0, "agrcondtlid"));
            this.a.add(var8.getItemValue(0, "agrcondtlid"));
         } else {
            if ("1".equals(var1)) {
               this.setItemValue(this.getRow(), "agrconno", "");
               this.setItemValue(this.getRow(), "invprice", "");
               this.setItemValue(this.getRow(), "unitprice", "");
               this.setItemValue(this.getRow(), "priceopcode", "XYJ");
               this.setItemValue(this.getRow(), "pricename", "协议价");
               this.setItemValue(this.getRow(), "priceid", "3");
            } else {
               this.setItemValue(this.getRow(), "agrconno", "");
               this.setItemValue(this.getRow(), "invprice", "");
            }

            for(int var6 = 0; var6 < var8.getRowCount(); ++var6) {
               this.a.add(var8.getItemValue(var6, "agrcondtlid"));
            }

         }
      } else {
         var2.setReadonly(true);
         this.setItemValue(this.getRow(), "agreementflag", "0");
         if ("0".equals(this.getItemValue(this.getRow(), "agreementflag"))) {
            this.getDBColumnDisplayInfo("unitprice").setReadonly(false);
         }

         this.setItemValue(this.getRow(), "agrconno", var8.getItemValue(0, ""));
         this.setItemValue(this.getRow(), "agrcondtlid", var8.getItemValue(0, ""));
         this.setItemValue(this.getRow(), "invprice", var8.getItemValue(0, ""));
         this.setItemValue(this.getRow(), "priceopcode", "XYJ");
         this.setItemValue(this.getRow(), "pricename", "协议价");
      }
   }

   protected int on_checkrownew(int var1, DBTableModel var2) {
      System.out.println(var2.getRowCount());
      String var4;
      if ((var4 = this.getItemValue(var1, "goodsqty")) != null && !var4.equals("") && DecimalHelper.toDec(var4).compareTo(DecimalHelper.toDec("0")) > 0) {
         String var3;
         if ((var3 = this.getItemValue(var1, "unitprice")) != null && !var3.equals("") && DecimalHelper.toDec(var3).compareTo(DecimalHelper.toDec("0")) >= 0) {
            var3 = this.getItemValue(var1, "webgoodsqty");
            var4 = DecimalHelper.trimZero(var4);
            if (var3 != null && !"".equals(var3) && DecimalHelper.comparaDecimal(var4, var3) > 0) {
               this.infoMessage("提示", "第" + (var1 + 1) + "行货品数量" + var4 + "大于原网上订单审批数量" + var3 + ",不能保存！");
               return -1;
            } else {
               return 0;
            }
         } else {
            this.infoMessage("提示", "第" + (var1 + 1) + "行单价必须大于等于0!~");
            return -1;
         }
      } else {
         this.infoMessage("提示", "第" + (var1 + 1) + "行数量必须大于0!~");
         return -1;
      }
   }

   public int on_beforesave() {
      if (this.getDBtableModel().getRowCount() <= 0) {
         return super.on_beforesave();
      } else {
         int var1 = this.getRowCount();
         boolean var2 = false;
         HashMap var3 = new HashMap();
         String var5;
         Double var6;
         if (var1 > 0) {
            for(int var4 = 0; var4 < var1; ++var4) {
               if (this.getdbStatus(var4) != 3) {
                  int var10;
                  if ((var10 = this.on_checkrownew(var4, this.dbmodel)) == -1) {
                     return var10;
                  }

                  var2 = true;
                  var5 = this.getItemValue(var4, "goodsid");
                  if (!var3.containsKey(var5)) {
                     var3.put(var5, Double.parseDouble(this.getItemValue(var4, "goodsqty")));
                  } else if (var3.containsKey(var5)) {
                     var6 = (Double)var3.get(var5) + Double.parseDouble(this.getItemValue(var4, "goodsqty"));
                     var3.remove(var5);
                     var3.put(var5, var6);
                  }
               }
            }
         }

         if (var2) {
            String var12 = "";
            String var11 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "entryid");
            var5 = null;
            var6 = null;
            Iterator var7 = var3.keySet().iterator();

            while(var7.hasNext()) {
               String var9 = (String)var7.next();
               var5 = "select leastsaleqty from pub_entry_goods t  where t.entryid = " + var11 + " and t.goodsid = " + var9;
               RemotesqlHelper var14 = new RemotesqlHelper();

               try {
                  DBTableModel var13;
                  if ((var13 = var14.doSelect(var5, 0, 2147483646)).getRowCount() > 0 && (var5 = var13.getItemValue(0, "leastsaleqty")).trim().length() > 0 && DecimalHelper.comparaDecimal(String.valueOf(DecimalHelper.toDec(String.valueOf(var3.get(var9))).remainder(DecimalHelper.toDec(var5))), "0") > 0) {
                     var12 = var12 + "货品ID为" + var9 + "的货品没有按照【货品基础数据管理】中设置的最小销售数量（" + var5 + "）的整数倍进行销售;";
                  }
               } catch (Exception var8) {
                  var8.printStackTrace();
               }
            }

            if (var12.trim().length() > 0) {
               var12 = var12 + "是否继续开单？";
               if (JOptionPane.showConfirmDialog(this.frame, var12, "提示", 0) == 1) {
                  return -1;
               }
            }
         }

         return super.on_beforesave();
      }
   }

   private static String a(String var0, DBTableModel var1, int var2) {
      String var12 = "";
      String var3 = null;
      String var5 = "";
      String var6 = var1.getItemValue(0, "factoryid");
      String var7 = var1.getItemValue(0, "goodsid");
      var3 = "select t.value\n  from Sys_npbusi_config_v t\n where t.keyword = 'managesqLetter'\n   and t.entryid = " + ClientUserManager.getCurrentUser().getEntryid();
      RemotesqlHelper var4 = new RemotesqlHelper();

      DBTableModel var13;
      try {
         if ((var13 = var4.doSelect(var3, 0, 1)) != null && var13.getRowCount() > 0) {
            var5 = var13.getItemValue(0, "value");
         }
      } catch (Exception var9) {
         var9.printStackTrace();
      }

      if ("1".equals(var5)) {
         if (var6 != null && !"".equals(var6)) {
            var3 = "select *\n  from Factory_author_doc t\n where t.factoryid =" + var1.getItemValue(0, "factoryid") + "   and t.entryid = " + ClientUserManager.getCurrentUser().getEntryid() + "   and t.Usestatus =1 and salestype =1 and Sqstartdate <=trunc(sysdate) and  trunc(Sqenddate) >= sysdate ";
            var4 = new RemotesqlHelper();

            try {
               if ((var13 = var4.doSelect(var3, 0, 1)) != null && var13.getRowCount() > 0) {
                  String var8 = var13.getItemValue(0, "coltype");
                  String var11 = var13.getItemValue(0, "authdocid");
                  var3 = "select * from  Factory_author_customer_dtl where customerid=" + var0 + " and authdocid =" + var11;
                  if ((var13 = (new RemotesqlHelper()).doSelect(var3, 0, 1)) != null && var13.getRowCount() > 0) {
                     if ("1".equals(var8)) {
                        var3 = "select * from  Factory_author_goods_dtl where Colvalueid=" + var7 + " and authdocid =" + var11;
                        if ((var13 = (new RemotesqlHelper()).doSelect(var3, 0, 1)) == null || var13.getRowCount() <= 0) {
                           var12 = "该货品ID：" + var7 + "没有授权给该客户，不能销售此货品";
                        }
                     } else if ("2".equals(var8)) {
                        var3 = "select * from  Factory_author_goods_dtl where authmxid= (select varietyid from pub_goods_v where goodsid = " + var7 + ") and authdocid =" + var11;
                        if ((var13 = (new RemotesqlHelper()).doSelect(var3, 0, 1)) == null || var13.getRowCount() <= 0) {
                           var12 = "该货品ID：" + var7 + "没有授权给该客户，不能销售此货品";
                        }
                     } else if ("3".equals(var8)) {
                        var3 = "select * from  Factory_author_goods_dtl where authmxid= (select varietydescid from pub_goods_v where goodsid = " + var7 + ") and authdocid =" + var11;
                        if ((var13 = (new RemotesqlHelper()).doSelect(var3, 0, 1)) == null || var13.getRowCount() <= 0) {
                           var12 = "该货品ID：" + var7 + "没有授权给该客户，不能销售此货品";
                        }
                     }

                     if ("4".equals(var8)) {
                        var3 = "select * from  Factory_author_goods_dtl where authmxid= (select vardesclassid from pub_goods_v where goodsid = " + var7 + ") and authdocid =" + var11;
                        if ((var13 = (new RemotesqlHelper()).doSelect(var3, 0, 1)) == null || var13.getRowCount() <= 0) {
                           var12 = "该货品ID：" + var7 + "没有授权给该客户，不能销售此货品";
                        }
                     }
                  } else {
                     var12 = "该货品生产厂家ID：" + var6 + "没有授权给该客户，不能销售此货品";
                  }
               } else {
                  var12 = "该生产厂家在该独立单元下没有有效的授权书，不能销售此货品";
               }
            } catch (Exception var10) {
               var10.printStackTrace();
            }
         } else {
            var12 = "没有取到该货品的生产厂家ID";
         }
      }

      return var12;
   }

   protected String getEditablecolumns(int var1) {
      ClientUserManager.getCurrentUser().getEntryid();
      int var2 = this.mdemodel.getMasterModel().getRow();
      String var3 = this.mdemodel.getMasterModel().getItemValue(var2, "usestatus");
      if ("1".equals(var3)) {
         if (!"3".equals(this.mdemodel.getMasterModel().getItemValue(var2, "contype"))) {
            return super.getEditablecolumns(var1);
         } else {
            String var5 = "goodsuseunit,goodsuseqty,priceopcode,lotmemo,speciallotflag,reqprintquflag,dtlmemo";
            var3 = this.getItemValue(var1, "priceid");
            String var4 = this.getItemValue(var1, "modifyflag");
            if (var3 != null && var3.trim().length() > 0 && var4 != null && var4.trim().length() > 0 && "1".equals(var4)) {
               this.getDBColumnDisplayInfo("unitprice").setReadonly(false);
               var5 = var5 + ",unitprice";
            } else if (var4 == null || "".equals(var4.trim())) {
               this.getDBColumnDisplayInfo("unitprice").setReadonly(false);
               var5 = var5 + ",unitprice";
            }

            return var5;
         }
      } else {
         return "nothing";
      }
   }
}
